﻿using System;
using System.Data;
using Infragistics.Web.UI.GridControls;

namespace test
{
    public partial class test1 : System.Web.UI.Page
    {
        int nbrBand0Rows = 10;

        protected void Page_Load(object sender, EventArgs e)
        {
            WebHierarchicalDataGrid grid = this.WebHierarchicalDataGrid1;

            Grid_Initialize(grid);
            PopulateDataSource(grid);
            grid.DataBind();
        }

        internal void Grid_Initialize(WebHierarchicalDataGrid grid)
        {
            grid.AutoGenerateColumns = false;
            grid.AutoGenerateBands = false;
            grid.InitialDataBindDepth = -1;
            grid.InitialExpandDepth = 0;

            grid.Columns.Clear();

            // calling this on an empty causes a null reference exception when the grid is bound.
            //grid.Bands.Clear();

            //grid.InitialDataBindDepth = -1;

            CreateColumn(grid, "", "CustomerAccountID", "AccountID", "CustomerAccountID", "System.Int32", 100, "", true, true);
            CreateColumn(grid, "", "AccountName", "Account", "AccountName", "System.String", 600, "", false, false);

            CreateColumn(grid, "0", "CustomerSubAccountID", "SubAccountID", "CustomerSubAccountID", "System.Int32", 100, "", true, true);
            CreateColumn(grid, "0", "CustomerAccountID", "AccountID", "CustomerAccountID", "System.Int32", 100, "", true, false);
            CreateColumn(grid, "0", "SubAccountName", "SubAccount", "SubAccountName", "System.String", 600, "", false, false);

            CreateColumn(grid, "00", "CustomerContactID", "ContactID", "CustomerContactID", "System.Int32", 100, "", true, true);
            CreateColumn(grid, "00", "CustomerSubAccountID", "SubAccountID", "CustomerSubAccountID", "System.Int32", 100, "", true, false);
            CreateColumn(grid, "00", "Name", "Name", "Name", "System.String", 200, "", false, false);
            CreateColumn(grid, "00", "Title", "Title", "Title", "System.String", 100, "", false, false);
            CreateColumn(grid, "00", "Email", "Email", "Email", "System.String", 100, "", false, false);
            CreateColumn(grid, "00", "Phone", "Phone", "Phone", "System.String", 100, "", false, false);

            CreateColumn(grid, "1", "CustomerContactID", "ContactID", "CustomerContactID", "System.Int32", 100, "", true, true);
            CreateColumn(grid, "1", "CustomerAccountID", "AccountID", "CustomerAccountID", "System.Int32", 100, "", true, false);
            CreateColumn(grid, "1", "Name", "Name", "Name", "System.String", 200, "", false, false);
            CreateColumn(grid, "1", "Title", "Title", "Title", "System.String", 100, "", false, false);
            CreateColumn(grid, "1", "Email", "Email", "Email", "System.String", 100, "", false, false);
            CreateColumn(grid, "1", "Phone", "Phone", "Phone", "System.String", 100, "", false, false);
        }

        internal BoundDataField CreateColumn(WebHierarchicalDataGrid grid, string band, string colName, string colHeaderText, string fieldName, string dataTypeName, int colWidth, string format, bool hidden, bool isDataKey)
        {
            if (band.Length > 4) throw new ArgumentException("Invalid band");
            int dummy;
            if (!string.IsNullOrEmpty(band)
                && !Int32.TryParse(band, out dummy)) throw new ArgumentException("Band is not a number");

            BoundDataField c = new BoundDataField();
            c.Key = colName;
            c.Header.Text = colHeaderText;
            c.DataFieldName = fieldName;
            c.DataFormatString = format;
            c.DataType = dataTypeName;
            c.Hidden = hidden;

            // not setting the width makes the columns extend to the grid width.
            // with multiple bands, the child band width is limited to the parent band width
            //c.Width = new Unit(colWidth);

            char[] bandElements = band.ToCharArray();
            int[] intBandElements = new int[band.Length];
            for (int i = 0; i < band.Length; i++)
            {
                intBandElements[i] = Convert.ToInt32(bandElements[i]) - 48;
            }

            // add a band, if required
            if (band.Length >= 1)
            {
                if (intBandElements[0] == grid.Bands.Count)
                    grid.Bands.Add(CreateBand());
                else if (intBandElements[0] > grid.Bands.Count)
                    throw new ArgumentException("Skipped a band value");
            }

            if (band.Length >= 2)
            {
                if (intBandElements[1] == grid.Bands[intBandElements[0]].Bands.Count)
                    grid.Bands[intBandElements[0]].Bands.Add(CreateBand());
                else if (intBandElements[1] > grid.Bands[intBandElements[0]].Bands.Count)
                    throw new ArgumentException("Skipped a band value");
            }

            if (band.Length >= 3)
            {
                if (intBandElements[2] == grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands.Count)
                    grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands.Add(CreateBand());
                else if (intBandElements[2] > grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands.Count)
                    throw new ArgumentException("Skipped a band value");
            }

            if (band.Length >= 4)
            {
                if (intBandElements[3] == grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].Bands.Count)
                    grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].Bands.Add(CreateBand());
                else if (intBandElements[3] > grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].Bands.Count)
                    throw new ArgumentException("Skipped a band value");
            }

            // add the column in the proper band
            if (band.Length == 0)
                grid.Columns.Add(c);
            else if (band.Length == 1)
                grid.Bands[intBandElements[0]].Columns.Add(c);
            else if (band.Length == 2)
                grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Columns.Add(c);
            else if (band.Length == 3)
                grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].Columns.Add(c);
            else if (band.Length == 4)
                grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].Bands[intBandElements[3]].Columns.Add(c);

            // set the DataKey in the proper band
            if (isDataKey)
            {
                if (band.Length == 0)
                    grid.DataKeyFields = fieldName;
                else if (band.Length == 1)
                    grid.Bands[intBandElements[0]].DataKeyFields = fieldName;
                else if (band.Length == 2)
                    grid.Bands[intBandElements[0]].Bands[intBandElements[1]].DataKeyFields = fieldName;
                else if (band.Length == 3)
                    grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].DataKeyFields = fieldName;
                else if (band.Length == 4)
                    grid.Bands[intBandElements[0]].Bands[intBandElements[1]].Bands[intBandElements[2]].Bands[intBandElements[3]].DataKeyFields = fieldName;
            }
            return c;
        }

        private Band CreateBand()
        {
            Band b = new Band();
            b.AutoGenerateColumns = false;
            return b;
        }

        internal void PopulateDataSource(WebHierarchicalDataGrid grid)
        {
            DataSet ds = new DataSet();
            DataSet ds1;
            DataTable dt;

            dt = new DataTable();
            dt.TableName = "CCM_CustomerAccounts";
            dt.Columns.Add("CustomerAccountID", typeof(int));
            dt.Columns.Add("AccountName", typeof(string));
            dt.PrimaryKey = new DataColumn[] { dt.Columns[0] };
            ds.Tables.Add(dt);

            for (int i = 1; i < nbrBand0Rows; i++)
            {
                dt.Rows.Add(new object[] { i, "A" + i });
            }

            dt = new DataTable();
            dt.TableName = "CCM_CustomerSubAccounts";
            dt.Columns.Add("CustomerSubAccountID", typeof(int));
            dt.Columns.Add("CustomerAccountID", typeof(int));
            dt.Columns.Add("SubAccountName", typeof(string));
            dt.PrimaryKey = new DataColumn[] { dt.Columns[0] };
            ds.Tables.Add(dt);

            for (int i = 1; i < nbrBand0Rows; i++)
            {
                dt.Rows.Add(new object[] { i, i, "B" + i });
            }

            dt.Rows.Add(new object[] { nbrBand0Rows + 0, nbrBand0Rows - 1, "B" + nbrBand0Rows + 0 });
            dt.Rows.Add(new object[] { nbrBand0Rows + 1, nbrBand0Rows - 1, "B" + nbrBand0Rows + 1 });
            dt.Rows.Add(new object[] { nbrBand0Rows + 2, nbrBand0Rows - 1, "B" + nbrBand0Rows + 2 });
            dt.Rows.Add(new object[] { nbrBand0Rows + 3, nbrBand0Rows - 1, "B" + nbrBand0Rows + 3 });
            dt.Rows.Add(new object[] { nbrBand0Rows + 4, nbrBand0Rows - 1, "B" + nbrBand0Rows + 4 });

            dt = new DataTable();
            dt.TableName = "CCM_CustomerContacts";
            dt.Columns.Add("CustomerContactID", typeof(int));
            dt.Columns.Add("CustomerAccountID", typeof(int));
            dt.Columns.Add("CustomerSubAccountID", typeof(int));
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Title", typeof(string));
            dt.Columns.Add("Email", typeof(string));
            dt.Columns.Add("Phone", typeof(string));
            dt.PrimaryKey = new DataColumn[] { dt.Columns[0] };
            ds.Tables.Add(dt);

            for (int i = 1; i < nbrBand0Rows; i++)
            {
                dt.Rows.Add(new object[] { i, i, i, "Name" + i, "Title" + i, "Email" + i, "Phone" + i });
            }

            dt.Rows.Add(new object[] { nbrBand0Rows + 0, nbrBand0Rows - 1, nbrBand0Rows + 0, "Name40", "Title40", "Email40", "Phone40" });
            dt.Rows.Add(new object[] { nbrBand0Rows + 1, nbrBand0Rows - 1, nbrBand0Rows + 1, "Name41", "Title41", "Email41", "Phone41" });
            dt.Rows.Add(new object[] { nbrBand0Rows + 2, nbrBand0Rows - 1, nbrBand0Rows + 2, "Name42", "Title42", "Email42", "Phone42" });
            dt.Rows.Add(new object[] { nbrBand0Rows + 3, nbrBand0Rows - 1, nbrBand0Rows + 3, "Name43", "Title43", "Email43", "Phone43" });
            dt.Rows.Add(new object[] { nbrBand0Rows + 4, nbrBand0Rows - 1, nbrBand0Rows + 4, "Name44", "Title44", "Email44", "Phone44" });

            Infragistics.Web.UI.DataSourceControls.DataView dv1;
            this.WebHierarchicalDataSource1.DataSource = ds;

            dv1 = new Infragistics.Web.UI.DataSourceControls.DataView();
            dv1.DataMember = "CCM_CustomerAccounts";
            dv1.ID = "CCM_CustomerAccounts";
            dv1.DataSource = ds;
            this.WebHierarchicalDataSource1.DataViews.Add(dv1);

            grid.DataMember = "CCM_CustomerAccounts";
            grid.Key = "CCM_CustomerAccounts";

            dv1 = new Infragistics.Web.UI.DataSourceControls.DataView();
            dv1.DataMember = "CCM_CustomerSubAccounts";
            dv1.ID = "CCM_CustomerSubAccounts";
            dv1.DataSource = ds;
            this.WebHierarchicalDataSource1.DataViews.Add(dv1);

            grid.Bands[0].DataMember = "CCM_CustomerSubAccounts";
            grid.Bands[0].Key = "CCM_CustomerSubAccounts";

            dv1 = new Infragistics.Web.UI.DataSourceControls.DataView();
            dv1.DataMember = "CCM_CustomerContacts";
            dv1.ID = "SubAcctContact";
            dv1.DataSource = ds;
            this.WebHierarchicalDataSource1.DataViews.Add(dv1);

            grid.Bands[0].Bands[0].DataMember = "SubAcctContact";
            grid.Bands[0].Bands[0].Key = "SubAcctContact";

            dv1 = new Infragistics.Web.UI.DataSourceControls.DataView();
            dv1.DataMember = "CCM_CustomerContacts";
            dv1.ID = "AcctContact";
            dv1.DataSource = ds;
            this.WebHierarchicalDataSource1.DataViews.Add(dv1);

            grid.Bands[1].DataMember = "AcctContact";
            grid.Bands[1].Key = "AcctContact";

            Infragistics.Web.UI.DataSourceControls.DataRelation dr1;
            dr1 = new Infragistics.Web.UI.DataSourceControls.DataRelation("CCM_CustomerAccounts", "CustomerAccountID", "CCM_CustomerSubAccounts", "CustomerAccountID");
            this.WebHierarchicalDataSource1.DataRelations.Add(dr1);

            dr1 = new Infragistics.Web.UI.DataSourceControls.DataRelation("CCM_CustomerAccounts", "CustomerAccountID", "AcctContact", "CustomerAccountID");
            this.WebHierarchicalDataSource1.DataRelations.Add(dr1);

            dr1 = new Infragistics.Web.UI.DataSourceControls.DataRelation("CCM_CustomerSubAccounts", "CustomerSubAccountID", "SubAcctContact", "CustomerSubAccountID");
            this.WebHierarchicalDataSource1.DataRelations.Add(dr1);

            grid.DataSource = this.WebHierarchicalDataSource1;
        }

    }
}
